# -*- encoding: utf-8 -*-
##############################################################################
#
#    school module for OpenERP
#    Copyright (C) 2010 Tecnoba S.L. (http://www.tecnoba.com)
#       Pere Ramon Erro Mas <pereerro@tecnoba.com> All Rights Reserved.
#
#    This file is a part of school modules
#
#    school OpenERP module is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    school OpenERP module is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import pooler
import xml.dom.minidom
from report.interface import report_rml
from report.interface import toxml

#FIXME: we should use toxml

class report_custom(report_rml):
    def create_xml(self, cr, uid, ids, datas, context={}):
        config = """
        <config>
            <date>09/09/2005</date>
            <PageSize>210.00mm,297.00mm</PageSize>
            <PageWidth>595.27</PageWidth>
            <PageHeight>841.88</PageHeight>
            <tableSize>60.00mm,60.00mm,60.00mm</tableSize>
            <report-header>Resum faltes per grup</report-header>
            <report-footer>Generated by Open ERP</report-footer>
        </config>
        """
        header = """
        <header>
        </header>
        """

        pool=pooler.get_pool(cr.dbname)

        datetime_from=datas['form']['date_from']
        datetime_to=datas['form']['date_to']
        group_ids=datas['form']['group'][0][2]

        xml=u'<rfpg><date_from>%s</date_from><date_to>%s</date_to>' % (datetime_from,datetime_to)

        groups=pool.get('groups.group').browse(cr, uid, group_ids, context={'withoutBlank': False,'datetime_from': datetime_from, 'datetime_to': datetime_to})
        for group in groups:
            xml+="<group><group_name>%s</group_name>" % group.name

            parts=set()
            for ga in group.assignation_ids:
                if ga.datetime_from<datetime_to and ga.datetime_to>datetime_from:
                    parts.add(ga.participation_id)
                parts.add(ga.participation_id)

            course_ids=[]
            for part in parts:
                for x in part.course_lines:
                    if x.course_id.id not in course_ids:
                        course_ids.append(x.course_id.id)
                        xml+="<course>%s</course>" % x.course_id.code

            for part in sorted(parts, key=lambda x:part.participant.name+', '+part.participant.first_name):
                xml+= """<participation>
                <name_student>%s</name_student>
                <first_name_student>%s</first_name_student>""" % (part.participant.name,part.participant.first_name)
                course_data_by_course=dict.fromkeys(course_ids, (0,0))
                for course_line in part.course_lines:
                    course_data_by_course[course_line.course_id.id]=(course_line.seance_hours,course_line.absence_hours)
                for course_id in course_ids:
                    xml+= """<course_data><seance_hours>%d</seance_hours><absence_hours>%d</absence_hours></course_data>""" % course_data_by_course[course_id]
                xml+= "</participation>"
            xml += "</group>"

        xml+= '</rfpg>'           
        xml = u'<?xml version="1.0" encoding="UTF-8" ?>' '<report>'+ config + header + xml + '</report>'
        print xml
        return self.post_process_xml_data(cr, uid, xml.encode("utf-8"), context)

report_custom('report.school.resum.participacio.per.grup', 'groups.group', '', 'addons/school_base/reports/resum_participacio_per_grup.xsl')

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

