<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:fo="http://www.w3.org/1999/XSL/Format">

	<xsl:import href="../../base/report/corporate_defaults.xsl"/>
	<xsl:import href="../../base/report/rml_template.xsl"/>

	<xsl:template name="first_page_frames">
		<frame id="main" x1="1cm" y1="2.5cm" width="19.0cm" height="23cm"/>
	</xsl:template>

	<xsl:template match="/">
		<xsl:call-template name="rml"/>
	</xsl:template>

	<!-- stylesheet -->

	<xsl:template name="stylesheet">
		<blockTableStyle id="detall_faltes_per_grup">
			<blockFont name="Helvetica-Bold" size="8" start="0,0" stop="-1,0"/>
			<blockBackground colorName="grey" start="0,0" stop="-1,0"/>
			<blockTextColor colorName="white" start="0,0" stop="-1,0"/>
			<blockValign value="TOP"/>
			<blockAlignment value="CENTER" start="0,0" stop="-1,0"/>
			<blockAlignment value="RIGHT" start="1,1" stop="-1,-1"/>
			<lineStyle kind="GRID" colorName="black"/>
		</blockTableStyle>
	</xsl:template>

	<xsl:template name="story">
		<xsl:apply-templates select="report/dfpg"/>
	</xsl:template>



	<xsl:template match="dfpg">
		<para>
			Data desde <xsl:value-of select="date_from"/>
		</para>
		<para>
			Data fins <xsl:value-of select="date_to"/>
		</para>
		<xsl:apply-templates select="group/participation"/>
		
	</xsl:template>

	<xsl:template match="participation">
		<spacer length="0.5cm"/>
		<para>ALUMNE <xsl:value-of select="@student_name" />, <xsl:value-of select="@student_first_name" />; GRUP <xsl:value-of select="../group_name"/></para>
		<blockTable colWidths="2cm,3cm,4cm,2.5cm,1.5cm,1.5cm,1.5cm,1.5cm,1.5cm" style="detall_faltes_per_grup" repeatRows="1">
			<tr>
				<td t="1">Data</td>
				<td t="1">Hora</td>
				<td t="1">Professor/a</td>
				<td t="1">Classe</td>
				<td t="1">Falta</td>
				<td t="1">Retard</td>
				<td t="1">Incidència</td>
				<td t="1">Expulsió</td>
				<td t="1">Estat</td>
			</tr>
			<xsl:apply-templates select="incidence"/>
		</blockTable>
		
	</xsl:template>
	<xsl:template match="incidence">
			<tr>
				<td t="1"><para><xsl:value-of select="@date"/></para></td>
				<td t="1"><para><xsl:value-of select="@duration"/></para></td>
				<td t="1"><para><xsl:value-of select="@teacher"/></para></td>
				<td t="1"><para><xsl:value-of select="@offer"/>-<xsl:value-of select="@course"/></para></td>
				<td t="1"><para><xsl:if test="@total>0">XXX</xsl:if></para></td>
				<td t="1"><para><xsl:if test="@delay>0">XXX</xsl:if></para></td>
				<td t="1"><para><xsl:if test="@incidence>0">XXX</xsl:if></para></td>
				<td t="1"><para><xsl:if test="@expulsion>0">XXX</xsl:if></para></td>
				<td t="1"><para><xsl:if test="@total_just+@delay_just=0">Jus</xsl:if><xsl:if test="@total_just+@delay_just>0">NO Jus</xsl:if></para></td>
			</tr>
		
	</xsl:template>
	
</xsl:stylesheet>
