# -*- encoding: utf-8 -*-
##############################################################################
#
#    school module for OpenERP
#    Copyright (C) 2010 Tecnoba S.L. (http://www.tecnoba.com)
#       Pere Ramon Erro Mas <pereerro@tecnoba.com> All Rights Reserved.
#
#    This file is a part of school modules
#
#    school OpenERP module is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    school OpenERP module is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import wizard
import pooler

form = '''<?xml version="1.0"?>
<form string="Impressio Detall Faltes Per Grup">
    <field name="date_from"/>
    <field name="date_to"/>
    <field name="group" colspan="4"/>
    <field name="teacher" domain="[('is_teacher','=',True)]" colspan="4"/>
    <field name="course" colspan="4" />
</form>'''

fields = {
  'group': {'string': 'Grup', 'type': 'many2many', 'relation': 'groups.group'},
  'teacher': {'string': 'Professor', 'type': 'many2many', 'relation': 'school.teacher'},
  'course': {'string': 'Course', 'type': 'many2many', 'relation': 'school.course'},
  'date_from': {'string': 'Des de data', 'type': 'date', 'required': True},
  'date_to': {'string': 'Fins a data', 'type': 'date', 'required': True},
}

class wizard_detall_faltes(wizard.interface):
    states = {
        'init': {
            'actions': [],
            'result': {'type': 'form', 'arch': form, 'fields': fields, 'state': (('end', 'Cancel'), ('print', 'Print'))},
        },
        'print': {
            'actions': [],
            'result': {'type':'print', 'report':'school.detall.faltes.per.grup', 'state':'end'},
        },
    }
wizard_detall_faltes('school.detall.faltes.wizard')

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

