# -*- coding: utf-8 -*-
##############################################################################
#
#    school module for OpenERP
#    Copyright (C) 2010 Tecnoba S.L. (http://www.tecnoba.com)
#       Pere Ramon Erro Mas <pereerro@tecnoba.com> All Rights Reserved.
#
#    This file is a part of school module
#
#    school OpenERP module is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    school OpenERP module is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


from osv import osv

class intervals:
    _intervals = []


    def add(self, datetime_from, datetime_to):
        def _inclou_interval_en_llista(llista, interval):
            ret=[]
            (dtf0,dtt0)=interval
            afegit=False
            for (dtf,dtt) in llista:
                if dtt<dtf0:
                    ret.append( (dtf,dtt) )
                elif dtt0<dtf:
                    if not afegit:
                        afegit=True
                        ret.append( (dtf0, dtt0 ) )
                    ret.append( (dtf,dtt) )
                else:
                    dtf0=min(dtf,dtf0)
                    dtt0=max(dtt,dtt0)
            if not afegit: ret.append( (dtf0, dtt0 ) )
            return ret
        self._intervals=_inclou_interval_en_llista(self._intervals, (datetime_from,datetime_to))

    def get(self):
        return self._intervals
    
    def size(self):
        return len(self._intervals)

class contact_annotation(osv.osv):
    _name = 'contact.annotation'
    _inherit = 'contact.annotation'

    def check_perms(self, cr, uid, ids, task, context=None):
        ret=[]
        ret=ret+super(contact_annotation, self).check_perms(cr, uid, ids, task, context=context)
        """
        Si l'usuari té un partner que imparteix una sessió, genera els permisos del grup X sobre el contacte, només en el temps d'aquella sessió 
        """
        ids=[x for x in ids if x not in ret]
        if not ids or task not in ('read','write','unlink','create'): return ret
        types_ok=self.pool.get('contact.type_annotation').search(cr, uid, [('perms_groups.group_id.name','=','Teacher In Seance'),('perms_groups.perm_'+task,'=',True)])
        teacher_ids=self.pool.get('school.teacher').search(cr, uid, [('user_id','=',uid)])+[0]
        
        if teacher_ids:
            cr.execute("SELECT id,anno_type,contact_id,valid_from,valid_to FROM contact_annotation WHERE id IN %s", (tuple(ids),))
            for (anno_id,anno_type,anno_contact_id,anno_datetime_from,anno_datetime_to) in cr.fetchall():
                if anno_type in types_ok:
                    # Init the intervals. We add the ok ranges on the base ranges array.
                    intvals=intervals()
                    parts_ids=self.pool.get('groups.participation').search(cr, uid, [('participant','=',anno_contact_id)])
                    query="""
                    SELECT ts.teacher_id,s.group_id,s.date,s.date_to
                    FROM school_teacher_seance AS ts, school_seance AS s
                    WHERE ts.teacher_id IN %(teacher_ids)s AND
                        ts.seance_id=s.id AND
                        s.date < %(datetime_to)s AND
                        s.date_to > %(datetime_from)s
                    """
                    cr.execute(query, {'teacher_ids': tuple(teacher_ids), 'datetime_from': anno_datetime_from, 'datetime_to': anno_datetime_to} )
                    for (partner_id,group_id,datetime_from,datetime_to) in cr.fetchall():
                        ga_ids=self.pool.get('groups.group_assignation').search(cr, uid, [('participation_id','in',parts_ids),('group_id','=',group_id),('datetime_from','<',datetime_to),('datetime_to','>',datetime_from)])
                        for data in self.pool.get('groups.group_assignation').read(cr, uid, ga_ids, ['datetime_from','datetime_to'], {'withoutBlank': False}):

                            datetime_from=max(datetime_from,data['datetime_from'],anno_datetime_from)
                            datetime_to=min(datetime_to,data['datetime_to'],anno_datetime_to)
                            intvals.add(datetime_from, datetime_to)
                    # Testing the base ranges array for the complete one.
                    if intvals.size()==1 and intvals.get()[0][0]==anno_datetime_from and intvals.get()[0][1]==anno_datetime_to:
                        ret.append(anno_id)
        return ret

contact_annotation()



# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
